package it.eng.spago.workflow.shark.impl;

import it.eng.spago.workflow.api.IWorkflowEngine;
import it.eng.spago.workflow.api.IWorkflowEngineFactory;

import java.io.InputStream;
import java.util.Properties;

import org.enhydra.shark.Shark;

/**
 * @author zoppello
 *
 * This is the implementation of the IWorkflowEngineFactory to istantiate a local Shark Engine
 */
public class SharkWorkflowEngineFactoryImpl implements IWorkflowEngineFactory{

	/**
	 * @see it.eng.spago.workflow.api.IWorkflowEngineFactory#getWorkflowEngine()
	 */
	public IWorkflowEngine getWorkflowEngine() {
		getWorkflowEngine("/Shark.conf");
		return new SharkWorkflowEngineImpl();
	}
	
	/**
	 * @see it.eng.spago.workflow.api.IWorkflowEngineFactory#getWorkflowEngine(java.lang.String)
	 */
	public IWorkflowEngine getWorkflowEngine(String configFilePath){
		try{
			InputStream is = this.getClass().getResourceAsStream(configFilePath);
			Properties properties = new Properties();
			properties.load(is);
			Shark.configure(properties);
			return new SharkWorkflowEngineImpl();
		}catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}
}
