package it.eng.spago.workflow.shark.impl;

import org.enhydra.shark.SharkUtilities;
import org.enhydra.shark.api.client.wfmodel.WfProcessMgr;

import it.eng.spago.workflow.api.IWorkflowProcessDefinition;
import it.eng.spago.workflow.api.WorkflowEngineException;

/**
 * @author zoppello
 *
 * The shark implementation of IWorkflowProcessDefinition
 */
public class SharkWorkflowProcessDefinition implements
		IWorkflowProcessDefinition {

	/**
	 * Shark internal object to manage process definition
	 */
	private WfProcessMgr wfProcessMgr = null;
	
	/**
	 * Constructor. Need a Shark specific wfProcessMgr
	 * @param wfProcessMgr
	 */
	public SharkWorkflowProcessDefinition(WfProcessMgr wfProcessMgr){
		this.wfProcessMgr = wfProcessMgr;
	}
	
	/**
	 * @see it.eng.spago.workflow.api.IWorkflowProcessDefinition#getProcessDefinitionId()
	 */
	public String getProcessDefinitionId() throws  WorkflowEngineException{
		
		try{
			String xpdlProcessId = SharkUtilities.getProcessMgrProcDefId(this.wfProcessMgr.name());
		
			return xpdlProcessId;
		}catch(Exception e){
			throw new WorkflowEngineException(e);
		}
	}
	/**
	 * @see it.eng.spago.workflow.api.IWorkflowProcessDefinition#getName()
	 */
	public String getName() throws WorkflowEngineException {
		try{
			return wfProcessMgr.name();
			
		}catch(Exception e){
			throw new WorkflowEngineException(e);
		}
	}
	
	/**
	 * @see it.eng.spago.workflow.api.IWorkflowProcessDefinition#getCategory()
	 */
	public String getCategory() throws WorkflowEngineException {
		try{
			return  wfProcessMgr.category();
			
		}catch(Exception e){
			throw new WorkflowEngineException(e);
		}
	}
	
	
	/**
	 * @see it.eng.spago.workflow.api.IWorkflowProcessDefinition#getVersion()
	 */
	public String getVersion() throws WorkflowEngineException {
		try{
			return wfProcessMgr.version();
			
		}catch(Exception e){
			throw new WorkflowEngineException(e);
		}
	}
	
	/**
	 * @see it.eng.spago.workflow.api.IWorkflowProcessDefinition#getDescription()
	 */
	public String getDescription() throws WorkflowEngineException {
		try{
			return wfProcessMgr.name();
			
		}catch(Exception e){
			throw new WorkflowEngineException(e);
		}
	}
}
