package it.eng.spago.workflow.test;

import it.eng.spago.workflow.api.IWorkflowAssignment;
import it.eng.spago.workflow.api.IWorkflowConnection;
import it.eng.spago.workflow.api.IWorkflowEngine;
import it.eng.spago.workflow.api.IWorkflowEngineFactory;
import it.eng.spago.workflow.api.IWorkflowProcess;
import it.eng.spago.workflow.shark.impl.SharkWorkflowEngineFactoryImpl;

import java.util.List;

public class TestExclusiveAccess {
	
	/**
	 * Two users with the same role
	 * if user A takes activity users two must not see it
	 */
	public static void main(String[] args) {
		try{
			IWorkflowEngineFactory wfEngineFactory = new SharkWorkflowEngineFactoryImpl();
			IWorkflowEngine wfEngine = wfEngineFactory.getWorkflowEngine();
			
			
			IWorkflowConnection wfConnection = wfEngine.getWorkflowConnection();
			wfConnection.open("admin","enhydra");
			
			//wfEngine.loadWorkflowsPackage("WellnessDemo2.xpdl");
			IWorkflowProcess aWfProcess = wfConnection.createProcess("WellnessDemo2","WellnessEvaluationProcess2");
			aWfProcess.start();
			
			
			// Creo il processo e lo faccio partire
			// A quetsi punto c'e' un'attivita' per il Survey Taker ( andrea o antonio )
			
			
			IWorkflowConnection wfConnectionAndrea = wfEngine.getWorkflowConnection();
			wfConnectionAndrea.open("andrea","andrea");
			
			List l = wfConnectionAndrea.getAssignments();
			System.out.print("ANDREA HA ["+l.size()+"] ATTIVITA'");
			for (int i = 0; i < l.size(); i++){
				System.out.println(l.get(i));
			}
			System.out.println("ANDREA ACCETTA L'ATTIVITA'");
			IWorkflowAssignment andreaAssigment = ((IWorkflowAssignment)l.get(0));
			
			
			andreaAssigment.accept();
			
			
		
			
			IWorkflowConnection wfConnectionAntonio = wfEngine.getWorkflowConnection();
			wfConnectionAntonio.open("antonio","antonio");
			
			l  = wfConnectionAntonio.getAssignments();
			
			System.out.print("ANTONIO HA ["+l.size()+"] ATTIVITA'");
			
			/*
			for (int i = 0; i < l.size(); i++){
				System.out.println(l.get(i));
			}
			*/
			System.out.print("ANDREA REJECT ACTIVITY");
			andreaAssigment.reject();
			
			l  = wfConnectionAntonio.getAssignments();
			
			System.out.print("ANTONIO HA ["+l.size()+"] ATTIVITA'");
			
			
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
}
