package it.eng.spago.workflow.api;


/**
 * @author zoppello
 *
 * This is the interface for the implemenation of the factory that return a workflow engine
 * 
 * All implementations of the SpagoWorkflowAPI MUST give an implementation of this class
 */
public interface IWorkflowEngineFactory {
	
	/**
	 * This is the factory method for getting IWorkflow Engine Instances
	 * @return the IWorkflow Engine instance
	 */
	public IWorkflowEngine getWorkflowEngine();
	
	
	/**
	 * This is the factory method for getting IWorkflow Engine Instances, specifyng a configuration file
	 * @return the IWorkflow Engine instance
	 */
	public IWorkflowEngine getWorkflowEngine(String configFilePath);
}
