package it.eng.spago.workflow.api;

/**
 * @author zoppello
 *
 * The interface that represent <b> Packages </b> in Spago Workflow API
 * 
 * In Spago Worrkflow API a Packages is a resource that contains Workflow Definitions
 * A package has:
 * 
 * <ul>
 * 	<li>A Package Identifier</li>
 * 	<li>A Package Version</li>
 * 	<li>A Definition File Name</li>
 * </ul>
 */
public interface IWorkflowPackage {
	
	/**
	 * @return the package ID
	 */
	public String getPackageID(); 
	
	/**
	 * @return the package Version
	 */
	public String getPackageVersion();

	/**
	 * @return the package defintion file Name
	 */
	public String getPackageDefinitionFileName();
	
	/**
	 * @return true if in the engine there are Process tha reference this package
	 * @throws WorkflowEngineException
	 */
	public boolean isReferenced() throws WorkflowEngineException;
	
	
	
}
