package it.eng.spago.workflow.api;


/**
 * @author zoppello
 * 
 * IWorkflowDefiniton objects represent the objects that in a workflow engine contains the 
 * process definition
 */
public interface IWorkflowProcessDefinition {
	
	/**
	 * This method retrieve the Process Definition Identifier
	 * @return The Process defintion Identifier
	 * @throws WorkflowEngineException
	 */
	public String getProcessDefinitionId() throws  WorkflowEngineException;
	
	/**
	 * This method retrieve the process definition name
	 * @return the name of the process
	 * @throws WorkflowEngineException
	 */
	public String getName() throws WorkflowEngineException;
	
	/**
	 * @return the category of the process definition
	 * @throws WorkflowEngineException
	 */
	public String getCategory() throws WorkflowEngineException;
	
	/**
	 * @return the version of the process definition
	 * @throws WorkflowEngineException
	 */
	public String getVersion() throws WorkflowEngineException;
	
	/**
	 * @return the description of the process defintion
	 * @throws WorkflowEngineException
	 */
	public String getDescription() throws WorkflowEngineException;
	
	
}
