

package it.eng.spago.workflow.worklist.tags;

import it.eng.spago.base.Constants;
import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.RequestContainerAccess;
import it.eng.spago.base.ResponseContainer;
import it.eng.spago.base.ResponseContainerAccess;
import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanAttribute;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.tracing.TracerSingleton;
import it.eng.spago.util.ContextScooping;
import it.eng.spago.util.JavaScript;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

/**
 * @author zoppello
 * 
 * Build the WorkList according to W3CAG
 */

public class ListTag extends TagSupport
{
	protected String _actionName = null;
	protected String _moduleName = null;
	protected String _serviceName = null;
	protected SourceBean _content = null;
	protected SourceBean _layout = null;
	protected String _providerURL = null;
	protected RequestContainer _requestContainer = null;
	protected SourceBean _serviceRequest = null;
	protected ResponseContainer _responseContainer = null;
	protected SourceBean _serviceResponse = null;
	protected StringBuffer _htmlStream = null;
	protected Vector _columns = null;
    protected String labelLinkSaltoPagina;
    protected String contextPath = null;
    protected String  imgFolder = null;
    
    private HttpServletRequest httpRequest = null;
    private HttpServletResponse httpResponse = null;
   
    private HashMap _providerUrlMap = new HashMap();
    
    
    /**
     *Consructor
     */
    public ListTag()
    {
    	labelLinkSaltoPagina = "Vai alla Pagina";	
    }

    
    public int doStartTag() throws JspException {
    	
    	this.contextPath = ((HttpServletRequest)pageContext.getRequest()).getContextPath();
    	this.httpResponse = ((HttpServletResponse)pageContext.getResponse());
     	TracerSingleton.log(
            Constants.NOME_MODULO,
            TracerSingleton.INFORMATION,
            "DefaultListTag::doStartTag:: invocato");
        HttpServletRequest httpRequest =
            (HttpServletRequest) pageContext.getRequest();
        _requestContainer =
            RequestContainerAccess.getRequestContainer(httpRequest);
        _serviceRequest = _requestContainer.getServiceRequest();
        _responseContainer =
            ResponseContainerAccess.getResponseContainer(httpRequest);
        _serviceResponse = _responseContainer.getServiceResponse();
        ConfigSingleton configure = ConfigSingleton.getInstance();
        if (_actionName != null) {
            _serviceName = _actionName;
            _content = _serviceResponse;
            SourceBean actionBean =
                (SourceBean) configure.getFilteredSourceBeanAttribute(
                    "ACTIONS.ACTION",
                    "NAME",
                    _actionName);
            _layout = (SourceBean) actionBean.getAttribute("CONFIG");
            _providerURL = "ACTION_NAME=" + _actionName;
        } // if (_actionName != null)
        else if (_moduleName != null) {
            _serviceName = _moduleName;
            _content = (SourceBean) _serviceResponse.getAttribute(_moduleName);
            SourceBean moduleBean =
                (SourceBean) configure.getFilteredSourceBeanAttribute(
                    "MODULES.MODULE",
                    "NAME",
                    _moduleName);
            _layout = (SourceBean) moduleBean.getAttribute("CONFIG");
            String pageName = (String) _serviceRequest.getAttribute("PAGE");
            _providerURL = "PAGE=" + pageName + "&MODULE=" + _moduleName + "&";
        } // if (_moduleName != null)
        else {
            TracerSingleton.log(
                Constants.NOME_MODULO,
                TracerSingleton.CRITICAL,
                "DefaultDetailTag::doStartTag:: service name non specificato !");
            throw new JspException("Business name non specificato !");
        } // if (_content == null)
        if (_content == null) {
            TracerSingleton.log(
                Constants.NOME_MODULO,
                TracerSingleton.WARNING,
                "DefaultDetailTag::doStartTag:: content nullo");
            return SKIP_BODY;
        } // if (_content == null)
        if (_layout == null) {
            TracerSingleton.log(
                Constants.NOME_MODULO,
                TracerSingleton.WARNING,
                "DefaultDetailTag::doStartTag:: layout nullo");
            return SKIP_BODY;
        } // if (_layout == null)
        _htmlStream = new StringBuffer();
        makeForm();
        try {
            pageContext.getOut().print(_htmlStream);
        } // try
        catch (Exception ex) {
            TracerSingleton.log(
                Constants.NOME_MODULO,
                TracerSingleton.CRITICAL,
                "DefaultListTag::doStartTag:: Impossibile inviare lo stream");
            throw new JspException("Impossibile inviare lo stream");
        } // catch (Exception ex)
        return SKIP_BODY;
    } // public int doStartTag() throws JspException

    
	
	
	
	
	/**
	 * Creates a form into the jsp page.
	 * 
	 * @throws JspException If any exception occurs.
	 */
	
	protected void makeForm() throws JspException {
		ConfigSingleton configure = ConfigSingleton.getInstance();
		SourceBean moduleBean =
			(SourceBean) configure.getFilteredSourceBeanAttribute("MODULES.MODULE", "NAME", _moduleName);

		//String titleCode = (String)moduleBean.getAttribute("CONFIG.TITLE");
		String title = (String)_layout.getAttribute("TITLE");
		_htmlStream.append(" <DIV>");
		_htmlStream.append(" 	<DIV>");
		_htmlStream.append(" 		<TABLE summary='"+title+"'>");
		_htmlStream.append(" 			<CAPTION>"+title+"</CAPTION>");
		makeTableHeaders();
		makeRows();
		_htmlStream.append(" 		</TABLE>");
		_htmlStream.append(" 	</DIV>");
		_htmlStream.append(" 	<DIV class='table-section-footer'>");
		navigationToolbar();
		_htmlStream.append(" 	</DIV>");
		_htmlStream.append("</DIV>");
		
		/*
		_htmlStream.append(" <table width=\"100%\" cellspacing=\"0\" border=\"0\">\n");		
		_htmlStream.append("	<tr height='40'>\n");
		_htmlStream.append("		<th align=middle> " + title + "</th>\n");
		_htmlStream.append("	</tr>\n");
		_htmlStream.append(" </table>\n");
		*/
		
		
		
		//makeNavigationButton();
		
		//_htmlStream.append(" <br/>\n");
		
		//makeButton();
		
		
	} // public void makeForm()
	
	protected void navigationToolbar() throws JspException {
		
		String pageNumberString = (String) _content.getAttribute("PAGED_LIST.PAGE_NUMBER");
		int pageNumber = 1;
		try {
			pageNumber = Integer.parseInt(pageNumberString);
		} 
		catch (NumberFormatException ex) {
			TracerSingleton.log(
				Constants.NOME_MODULO,
				TracerSingleton.WARNING,
				"ListTag::makeNavigationButton:: PAGE_NUMBER nullo");
		} 
		String pagesNumberString = (String) _content.getAttribute("PAGED_LIST.PAGES_NUMBER");
		int pagesNumber = 1;
		try {
			pagesNumber = Integer.parseInt(pagesNumberString);
		} 
		catch (NumberFormatException ex) {
			TracerSingleton.log(
				Constants.NOME_MODULO,
				TracerSingleton.WARNING,
				"ListTag::makeNavigationButton:: PAGES_NUMBER nullo");
		} 

		int prevPage = pageNumber - 1;
		if (prevPage < 1)
			prevPage = 1;
		int nextPage = pageNumber + 1;
		if (nextPage > pagesNumber)
			nextPage = pagesNumber;
		
		
		// get the right parameters of the request
		HashMap paramsMap  = getQueryStringParameter();
		// add the parameter for the provider
		paramsMap.putAll(_providerUrlMap);
				
		
        // create link for previous page
		HashMap prevParamsMap = paramsMap;
		prevParamsMap.put("MESSAGE", "LIST_PAGE");
		prevParamsMap.put("LIST_PAGE", String.valueOf(prevPage));
		String prevUrl = createUrl(prevParamsMap);				
		String imgTag = "<IMG alt='Previous Page' src='"+httpResponse.encodeRedirectURL(contextPath  + imgFolder + "/prevPage.gif")+"'/>\n";
		if(pageNumber != 1) {	
			_htmlStream.append("		<A href=\""+prevUrl.toString()+"\">"+imgTag+"</a>\n"); 
		} else {
			_htmlStream.append(imgTag);
		}		
		
		String pageLabel = "Page";
		String pageOfLabel = "Of";
		
		_htmlStream.append("							&nbsp;"+pageLabel+ " " + pageNumber + " " +pageOfLabel+ " " + pagesNumber + "&nbsp;\n");
		
		
		
		
		HashMap nextParamsMap = paramsMap;
		nextParamsMap.put("MESSAGE", "LIST_PAGE");
		nextParamsMap.put("LIST_PAGE", String.valueOf(nextPage));
		String nextUrl = createUrl(nextParamsMap);	
		String imgNextTag = "<IMG alt='Next Page' src='"+httpResponse.encodeRedirectURL(contextPath  + imgFolder + "/nextPage.gif")+"'/>\n";
		if(pageNumber != pagesNumber) {	
			_htmlStream.append("		<A href=\""+nextUrl.toString()+"\">"+imgNextTag+"</a>\n"); 
		} else {
			_htmlStream.append(imgNextTag);
		}		 
	} 
	
	/**
	 * Builds Table list columns, reading all request information.
	 * 
	 * @throws JspException If any Exception occurs.
	 */
	
	protected void makeTableHeaders() throws JspException {
		
		SourceBean captionSB = (SourceBean)_layout.getAttribute("CAPTIONS");
		List captions = captionSB.getContainedSourceBeanAttributes();
		int numCaps = captions.size();
		
		_columns = new Vector();
		List columnsVector = _layout.getAttributeAsList("COLUMNS.COLUMN");
		for (int i = 0; i < columnsVector.size(); i++) {
			String hidden = (String)((SourceBean) columnsVector.get(i)).getAttribute("HIDDEN");
			if (hidden == null || hidden.trim().equalsIgnoreCase("FALSE"))
				_columns.add((SourceBean) columnsVector.get(i));
		}
		if ((_columns == null) || (_columns.size() == 0)) {
			TracerSingleton.log(
					"ListTag",
					TracerSingleton.CRITICAL,
					"ListTag::makeTableHeaders: Columns names not defined");
			throw new JspException("Columns names not defined");
		} 
		
		
		
		_htmlStream.append("	<TR>\n");
		for (int i = 0; i < _columns.size(); i++) {
			String nameColumnCode = (String) ((SourceBean) _columns.elementAt(i)).getAttribute("LABEL");
			String nameColumn = nameColumnCode;
			_htmlStream.append("<TH scope='col' class='table-section-header'>" + nameColumn + "</TH>\n");
		} 
		for(int i=0; i<numCaps; i++) {
			
			_htmlStream.append("<TH scope='col' class='table-section-header'>&nbsp;</TH>\n");
		} 
		_htmlStream.append("</TR>\n");
	} 
	
	
	
	
	
	/**
	 * Builds Table list rows, reading all query information.
	 * 
	 * @throws JspException If any Exception occurs.
	 */
	
	
	protected void makeRows() throws JspException 
	{
		
		List rows = _content.getAttributeAsList("PAGED_LIST.ROWS.ROW");
	    
		
		boolean alternate = false;
        String rowClass;
		for(int i = 0; i < rows.size(); i++) 
		{
			SourceBean row = (SourceBean) rows.get(i);
            
            rowClass = (alternate) ? "table-section-alternate" : "table-section-body";
            alternate = !alternate;    
            
            _htmlStream.append(" <tr class='table-font'>\n");
			for (int j = 0; j < _columns.size(); j++) {
				String nameColumn = (String) ((SourceBean) _columns.elementAt(j)).getAttribute("NAME");
				Object fieldObject = row.getAttribute(nameColumn);
				String field = null;
				if (fieldObject != null)
					field = fieldObject.toString();
				else
					field = "&nbsp;";
				_htmlStream.append(" <td class='" + rowClass + "'>" + field + "</td>\n");
			} 
			
			
			SourceBean captionsSB = (SourceBean)_layout.getAttribute("CAPTIONS");
			List captions = captionsSB.getContainedSourceBeanAttributes();
			Iterator iter = captions.iterator();
			while(iter.hasNext()) {
				SourceBeanAttribute captionSBA = (SourceBeanAttribute)iter.next();
				SourceBean captionSB = (SourceBean)captionSBA.getValue();
				List parameters = captionSB.getAttributeAsList("PARAMETER");
				
				String img = (String)captionSB.getAttribute("image");
				String labelCode = (String)captionSB.getAttribute("label");
				String label = labelCode;
				
	            StringBuffer parametersStr = getParametersList(parameters, row);
				boolean confirm = false;
				/*
				if (captionSB.getAttribute("confirm") != null &&
						((String)captionSB.getAttribute("confirm")).equalsIgnoreCase("TRUE")){
					confirm = true;
				}
				*/
				_htmlStream.append(" <td width='20' class='" + rowClass + "'>\n");
				if (confirm){
					_htmlStream.append("     <a href='javascript:actionConfirm(\"" + label + "\", \"" + parametersStr.toString() + "\");'>\n");	
				}else{
					_htmlStream.append("     <a href='"+parametersStr.toString()+"'>\n");	
				}
				_htmlStream.append("			<img title='"+label+"' alt='"+label+"' src='"+contextPath + imgFolder + "/"+img+"' />\n");
				_htmlStream.append("     </a>\n");
				_htmlStream.append(" </td>\n");
				
			}
			_htmlStream.append(" </tr>\n");
		}
		
		_htmlStream.append(" </table>\n");
	} 
	
	
	
	/*
	protected void makeNavigationButton() throws JspException {
		
		String pageNumberString = (String) _content.getAttribute("PAGED_LIST.PAGE_NUMBER");
		int pageNumber = 1;
		try {
			pageNumber = Integer.parseInt(pageNumberString);
		} 
		catch (NumberFormatException ex) {
			TracerSingleton.log(
				Constants.NOME_MODULO,
				TracerSingleton.WARNING,
				"ListTag::makeNavigationButton:: PAGE_NUMBER nullo");
		} 
		String pagesNumberString = (String) _content.getAttribute("PAGED_LIST.PAGES_NUMBER");
		int pagesNumber = 1;
		try {
			pagesNumber = Integer.parseInt(pagesNumberString);
		} 
		catch (NumberFormatException ex) {
			TracerSingleton.log(
				Constants.NOME_MODULO,
				TracerSingleton.WARNING,
				"ListTag::makeNavigationButton:: PAGES_NUMBER nullo");
		} 

		int prevPage = pageNumber - 1;
		if (prevPage < 1)
			prevPage = 1;
		int nextPage = pageNumber + 1;
		if (nextPage > pagesNumber)
			nextPage = pagesNumber;
		
		
		// get the right parameters of the request
		HashMap paramsMap  = getQueryStringParameter();
		// add the parameter for the provider
		paramsMap.putAll(_providerUrlMap);
				
		_htmlStream.append(" <DIV align='center'>\n");
//		_htmlStream.append("	<TR>\n");
		_htmlStream.append("		<span class='table-section-footer' valign='center' align='left' width='14'>\n");
						
        // create link for previous page
		HashMap prevParamsMap = paramsMap;
		prevParamsMap.put("MESSAGE", "LIST_PAGE");
		prevParamsMap.put("LIST_PAGE", String.valueOf(prevPage));
		String prevUrl = createUrl(prevParamsMap);				
		String imgTag = "<IMG src='"+httpResponse.encodeRedirectURL(contextPath  + imgFolder + "prevPage.gif")+"' ALIGN=RIGHT border=0>\n";
		if(pageNumber != 1) {	
			_htmlStream.append("		<A href=\""+prevUrl.toString()+"\">"+imgTag+"</a>\n"); 
		} else {
			_htmlStream.append(imgTag);
		}		
		_htmlStream.append("		</span>\n");
				
		// create center blank cell
		//_htmlStream.append("		<TD class='table-section-footer'>&nbsp;</TD>\n");
		
        // visualize page numbers
		String pageLabel = "Page";
		String pageOfLabel = "Page Of";
		_htmlStream.append("		<span class='table-section-footer' align='center'>\n");
		_htmlStream.append("							&nbsp;"+pageLabel+ " " + pageNumber + " " +pageOfLabel+ " " + pagesNumber + "&nbsp;\n");
		_htmlStream.append("		</span>\n");
		
		
		// create link for next page
		_htmlStream.append("		<span class='table-section-footer' valign='center' align='right' width='14'>\n");
		HashMap nextParamsMap = paramsMap;
		nextParamsMap.put("MESSAGE", "LIST_PAGE");
		nextParamsMap.put("LIST_PAGE", String.valueOf(nextPage));
		String nextUrl = createUrl(nextParamsMap);				
		if(pageNumber != pagesNumber) {	
			_htmlStream.append("		<A href=\""+nextUrl.toString()+"\"><IMG src='"+httpResponse.encodeURL(contextPath + imgFolder + "nextPage.gif")+"' ALIGN=RIGHT border=0></a>\n"); 
		} else {
			_htmlStream.append("		<IMG src='"+httpResponse.encodeURL(contextPath + imgFolder + "nextPage.gif")+"' ALIGN=RIGHT border=0>\n");
		}		 
		_htmlStream.append("		</span>\n");
//		_htmlStream.append("	</TR>\n");
		_htmlStream.append("</DIV>\n");
	} */
	
	
	
	protected void makeNavigationButton() throws JspException {
		
		String pageNumberString = (String) _content.getAttribute("PAGED_LIST.PAGE_NUMBER");
		int pageNumber = 1;
		try {
			pageNumber = Integer.parseInt(pageNumberString);
		} 
		catch (NumberFormatException ex) {
			TracerSingleton.log(
				Constants.NOME_MODULO,
				TracerSingleton.WARNING,
				"ListTag::makeNavigationButton:: PAGE_NUMBER nullo");
		} 
		String pagesNumberString = (String) _content.getAttribute("PAGED_LIST.PAGES_NUMBER");
		int pagesNumber = 1;
		try {
			pagesNumber = Integer.parseInt(pagesNumberString);
		} 
		catch (NumberFormatException ex) {
			TracerSingleton.log(
				Constants.NOME_MODULO,
				TracerSingleton.WARNING,
				"ListTag::makeNavigationButton:: PAGES_NUMBER nullo");
		} 

		int prevPage = pageNumber - 1;
		if (prevPage < 1)
			prevPage = 1;
		int nextPage = pageNumber + 1;
		if (nextPage > pagesNumber)
			nextPage = pagesNumber;
		
		
		// get the right parameters of the request
		HashMap paramsMap  = getQueryStringParameter();
		// add the parameter for the provider
		paramsMap.putAll(_providerUrlMap);
				
		_htmlStream.append(" <TABLE align='center'>\n");
		_htmlStream.append("	<TR>\n");
		_htmlStream.append("		<TD class='table-section-footer' valign='center' align='left' width='14'>\n");
						
        // create link for previous page
		HashMap prevParamsMap = paramsMap;
		prevParamsMap.put("MESSAGE", "LIST_PAGE");
		prevParamsMap.put("LIST_PAGE", String.valueOf(prevPage));
		String prevUrl = createUrl(prevParamsMap);				
		String imgTag = "<IMG src='"+httpResponse.encodeRedirectURL(contextPath  + imgFolder + "/prevPage.gif")+"' ALIGN=RIGHT border=0>\n";
		if(pageNumber != 1) {	
			_htmlStream.append("		<A href=\""+prevUrl.toString()+"\">"+imgTag+"</a>\n"); 
		} else {
			_htmlStream.append(imgTag);
		}		
		_htmlStream.append("		</TD>\n");
				
		// create center blank cell
		//_htmlStream.append("		<TD class='table-section-footer'>&nbsp;</TD>\n");
		
        // visualize page numbers
		String pageLabel = "Page";
		String pageOfLabel = "Page Of";
		_htmlStream.append("		<TD class='table-section-footer' align='center'>\n");
		_htmlStream.append("							&nbsp;"+pageLabel+ " " + pageNumber + " " +pageOfLabel+ " " + pagesNumber + "&nbsp;\n");
		_htmlStream.append("		</TD>\n");
		
		
		// create link for next page
		_htmlStream.append("		<TD class='table-section-footer' valign='center' align='right' width='14'>\n");
		HashMap nextParamsMap = paramsMap;
		nextParamsMap.put("MESSAGE", "LIST_PAGE");
		nextParamsMap.put("LIST_PAGE", String.valueOf(nextPage));
		String nextUrl = createUrl(nextParamsMap);				
		if(pageNumber != pagesNumber) {	
			_htmlStream.append("		<A href=\""+nextUrl.toString()+"\"><IMG src='"+httpResponse.encodeURL(contextPath + imgFolder + "/nextPage.gif")+"' ALIGN=RIGHT border=0></a>\n"); 
		} else {
			_htmlStream.append("		<IMG src='"+httpResponse.encodeURL(contextPath + imgFolder + "/nextPage.gif")+"' ALIGN=RIGHT border=0>\n");
		}		
		_htmlStream.append("		</TD>\n");
		_htmlStream.append("	</TR>\n");
		_htmlStream.append("</TABLE>\n");
	} 
	
	
	
	
	/**
	 * Starting from the module <code>buttonsSB</code> object, 
	 * creates all buttons for the jsp list. 
	 * 
	 * @throws JspException If any exception occurs.
	 */
	/*
	protected void makeButton() throws JspException {

		_htmlStream.append("<table width='100%'\n");
		_htmlStream.append("	<tr>\n");
		_htmlStream.append("		<td>&nbsp;</td>\n");
				
		SourceBean buttonsSB = (SourceBean)_layout.getAttribute("BUTTONS");
		List buttons = buttonsSB.getContainedSourceBeanAttributes();
		Iterator iter = buttons.listIterator();
		while(iter.hasNext()) {
			SourceBeanAttribute buttonSBA = (SourceBeanAttribute)iter.next();
			SourceBean buttonSB = (SourceBean)buttonSBA.getValue();
			List parameters = buttonSB.getAttributeAsList("PARAMETER");
			HashMap paramsMap = getParametersMap(parameters, null);
			
			String img = (String)buttonSB.getAttribute("image");
			String labelCode = (String)buttonSB.getAttribute("label");
			
			String label = labelCode;
			
			String buttonUrl = createUrl(paramsMap);
			
			_htmlStream.append("		<td width='150px' align='center'>\n");
			_htmlStream.append("			<a href='"+buttonUrl.toString()+"'><img src='"+httpResponse.encodeURL(contextPath + img)+"' /></a><br/>\n");
			_htmlStream.append("		    <a href='"+buttonUrl.toString()+"' class='table-menu-item' >"+label+"</a>\n");
			_htmlStream.append("		</td>\n");
		}
		
		_htmlStream.append("		<td>&nbsp;</td>\n");
		_htmlStream.append("	</tr>\n");
		_htmlStream.append("</table>\n");
		_htmlStream.append("<br/><br/>\n");
	} 
	*/
		
	/**
	 * Gets all parameter information from a module, putting them into a HashMap.
	 * 
	 * @param parameters The parameters list
	 * @param row The value objects Source Bean 
	 * @return The parameters Hash Map
	 * @throws JspException If any Exception occurred
	 */
	
	protected HashMap getParametersMap(List parameters, SourceBean row) throws JspException {
		
		HashMap params = new HashMap(); 
       
		for (int i = 0; i < parameters.size(); i++) {
			String name = (String) ((SourceBean) parameters.get(i)).getAttribute("NAME");
			String type = (String) ((SourceBean) parameters.get(i)).getAttribute("TYPE");
			String value = (String) ((SourceBean) parameters.get(i)).getAttribute("VALUE");
			String scope = (String) ((SourceBean) parameters.get(i)).getAttribute("SCOPE");
			
			if (name != null) {
				name = JavaScript.escape(name.toUpperCase());
								
				if ((type != null) && type.equalsIgnoreCase("RELATIVE")) {
					if ((scope != null) && scope.equalsIgnoreCase("LOCAL")) {
						if (row == null) {
							TracerSingleton.log(
									"ListTag",
									TracerSingleton.CRITICAL,
									"ListTag::getParametersMap: Impossible to associate local scope to the button");
							throw new JspException("Impossible to associate local scope to the button");
						} // if (row == null)
						Object valueObject = row.getAttribute(value);
						if (valueObject != null)
							value = valueObject.toString();
					} // if ((scope != null) && scope.equalsIgnoreCase("LOCAL"))
					else
						value =	(String)(ContextScooping.getScopedParameter(_requestContainer, _responseContainer, value, scope)).toString();
				} // if ((type != null) && type.equalsIgnoreCase("RELATIVE"))
				if (value == null)
					value = "";
				value = JavaScript.escape(value);
			} // if (name != null)
			
			params.put(name, value);
			
		} // for (int i = 0; i < parameters.size(); i++)
		return params;
	} // protected StringBuffer getParametersList(Vector parameters, SourceBean row) throws JspException

	
	/**
	 * From the parameter HashMap at input, creates the reference navigation url.
	 * 
	 * @param paramsMap The parameter HashMap
	 * @return A <code>String</code> object representing the navigation URL
	 */
	protected String createUrl(HashMap paramsMap) {
	
		StringBuffer url = new StringBuffer();
		url.append("AdapterHTTP?");
		url.append(_providerURL);
		Set paramsKeys = paramsMap.keySet();
		Iterator iter = paramsKeys.iterator();
		while(iter.hasNext()) {
			String paramKey = (String)iter.next();
			String paramValue = (String)paramsMap.get(paramKey);
			paramKey = JavaScript.escape(paramKey.toUpperCase());
			paramValue = JavaScript.escape(paramValue.toUpperCase());
            url.append("&"+paramKey+"="+ paramValue); 		
		}
		return url.toString();
		
	}
	
	/**
	 * Gets the query parameters from request and puts them into an hashMap.
	 * 
	 * @return The hash map containing query parameters.
	 */
	protected HashMap getQueryStringParameter() {
		
		HashMap params = new HashMap();
		StringBuffer queryStringBuffer = new StringBuffer();
		List queryParameters = _serviceRequest.getContainedAttributes();
		
		for (int i = 0; i < queryParameters.size(); i++) {			
			SourceBeanAttribute parameter = (SourceBeanAttribute) queryParameters.get(i);
			String parameterKey = parameter.getKey();
			if (parameterKey.equalsIgnoreCase("ACTION_NAME")
				|| parameterKey.equalsIgnoreCase("PAGE")
				|| parameterKey.equalsIgnoreCase("MODULE")
				|| parameterKey.equalsIgnoreCase("MESSAGE")
				|| parameterKey.equalsIgnoreCase("LIST_PAGE")
				|| parameterKey.equalsIgnoreCase("LIST_NOCACHE")
				|| parameterKey.equalsIgnoreCase("NAVIGATOR_DISABLED")
				|| parameterKey.equalsIgnoreCase("NAVIGATOR_RESET"))
				continue;
			String parameterValue = parameter.getValue().toString();
			params.put(parameterKey, parameterValue);
		} // for (int i = 0; i < queryParameters.size(); i++)
		return params;
	} // protected String getQueryString()

	
	/**
	 * Traces the setting of an action name.
	 * 
	 * @param actionName The action name string at input. 
	 */
	public void setActionName(String actionName) {
		TracerSingleton.log(
			Constants.NOME_MODULO,
			TracerSingleton.DEBUG,
			"ListTag::setActionName:: actionName [" + actionName + "]");
		_actionName = actionName;
	} // public void setActionName(String actionName)

	/**
	 * Traces the setting of a module name.
	 * 
	 * @param moduleName The module name string at input. 
	 */
	
	public void setModuleName(String moduleName) {
		TracerSingleton.log(
			Constants.NOME_MODULO,
			TracerSingleton.INFORMATION,
			"ListTag::setModuleName:: moduleName [" + moduleName + "]");
		_moduleName = moduleName;
	} // public void setModuleName(String moduleName)

	/**
	 * @see javax.servlet.jsp.tagext.Tag#doEndTag()
	 */
	
	public int doEndTag() throws JspException {
		TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.INFORMATION, "ListTag::doEndTag:: invocato");
		_actionName = null;
		_moduleName = null;
		_serviceName = null;
		_content = null;
		_layout = null;
		_providerURL = null;
		_requestContainer = null;
		_serviceRequest = null;
		_responseContainer = null;
		_serviceResponse = null;
		_htmlStream = null;
		_columns = null;
		return super.doEndTag();
	} // public int doEndTag() throws JspException
	
	protected StringBuffer getParametersList(List parameters, SourceBean row)
    throws JspException {
    StringBuffer parametersList = new StringBuffer();
    parametersList.append("AdapterHTTP?");
    for (int i = 0; i < parameters.size(); i++) {
        String name =
            (String) ((SourceBean) parameters.get(i)).getAttribute(
                "NAME");
        String type =
            (String) ((SourceBean) parameters.get(i)).getAttribute(
                "TYPE");
        String value =
            (String) ((SourceBean) parameters.get(i)).getAttribute(
                "VALUE");
        String scope =
            (String) ((SourceBean) parameters.get(i)).getAttribute(
                "SCOPE");
        if (name != null) {
            parametersList.append(
                JavaScript.escape(name.toUpperCase()) + "=");
            if ((type != null) && type.equalsIgnoreCase("RELATIVE")) {
                if ((scope != null) && scope.equalsIgnoreCase("LOCAL")) {
                    if (row == null) {
                        TracerSingleton.log(
                            Constants.NOME_MODULO,
                            TracerSingleton.CRITICAL,
                            "DefaultListTag::getParametersList: Non ? possibile associare a questo bottone lo scope LOCAL");
                        throw new JspException("Non ? possibile associare a questo bottone lo scope LOCAL");
                    } // if (row == null)
                    Object valueObject = row.getAttribute(value);
                    if (valueObject != null)
                        value = valueObject.toString();
                } // if ((scope != null) && scope.equalsIgnoreCase("LOCAL"))
                else
                    value =
                        (String) ContextScooping.getScopedParameter(
                            _requestContainer,
                            _responseContainer,
                            value,
                            scope);
            } // if ((type != null) && type.equalsIgnoreCase("RELATIVE"))
            if (value == null)
                value = "";
            parametersList.append(JavaScript.escape(value) + "&");
        } // if (name != null)
    } // for (int i = 0; i < parameters.size(); i++)
    return  parametersList;
} // protected StringBuffer getParametersList(Vector parameters, SourceBean row) throws JspException


	public String getImgFolder() {
		return imgFolder;
	}


	public void setImgFolder(String imgFolder) {
		this.imgFolder = imgFolder;
	}
} // public class ListTag extends TagSupport



































